﻿
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid
Imports System.ComponentModel

Class MyCreation
    Inherits Component
    Implements IUIElementCreationFilter

    Public Custom Event OnAfterCellCreated As EventHandler
        AddHandler(value As EventHandler)
            Me.Events.AddHandler("AfterCellCreated", value)
            AfterCellCreatedHandler = CType(Me.Events("AfterCellCreated"), EventHandler)
        End AddHandler

        RemoveHandler(value As EventHandler)
            Me.Events.RemoveHandler("AfterCellCreated", value)
        End RemoveHandler

        RaiseEvent(sender As Object, e As CellCreatedArgs)
            CType(Me.Events("AfterCellCreated"), EventHandler).Invoke(sender, e)
        End RaiseEvent
    End Event
    Dim AfterCellCreatedHandler As EventHandler
    Dim shouldRiseAfterCellCreated = False
    Dim grid As UltraGrid

    Private _ultraGridColumn As Infragistics.Win.UltraWinGrid.UltraGridColumn

    Sub New(ultraGridColumn As Infragistics.Win.UltraWinGrid.UltraGridColumn)
        ' TODO: Complete member initialization 
        _ultraGridColumn = ultraGridColumn
        grid = ultraGridColumn.Band.Layout.Grid
        AddHandler grid.AfterRowExpanded, AddressOf grid_AfterRowExpanded


    End Sub

    Private Sub grid_AfterRowExpanded(sender As System.Object, e As Infragistics.Win.UltraWinGrid.RowEventArgs)
        shouldRiseAfterCellCreated = True
    End Sub

    Public Sub AfterCreateChildElements(parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        If TypeOf parent Is TextUIElement Then
            Dim cell As CellUIElement = parent.GetAncestor(GetType(CellUIElement))
            If cell IsNot Nothing Then
                If cell.Cell.Column.Equals(_ultraGridColumn) And AfterCellCreatedHandler IsNot Nothing And shouldRiseAfterCellCreated Then
                    AfterCellCreatedHandler.Invoke(_ultraGridColumn.Band.Layout.Grid, New CellCreatedArgs(cell.Cell))
                    shouldRiseAfterCellCreated = False

                End If
            End If
        End If

    End Sub

    Public Function BeforeCreateChildElements(parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False

    End Function


End Class

Public Class CellCreatedArgs
    Inherits EventArgs
    Private m_cell As UltraGridCell
    Public ReadOnly Property Cell() As UltraGridCell
        Get
            Return m_cell
        End Get
    End Property

    Sub New(cell As UltraGridCell)
        Me.m_cell = cell
    End Sub

End Class
